diff --git a/sysdeps/i386/fpu/libm-test-ulps b/sysdeps/i386/fpu/libm-test-ulps
index 5dc2bbaeff..7601049110 100644
--- a/sysdeps/i386/fpu/libm-test-ulps
+++ b/sysdeps/i386/fpu/libm-test-ulps
@@ -1252,49 +1252,49 @@ ldouble: 1
 
 Function: "j0":
 double: 5
-float: 8
+float: 9
 float128: 2
 ldouble: 8
 
 Function: "j0_downward":
 double: 5
-float: 4
+float: 9
 float128: 9
 ldouble: 6
 
 Function: "j0_towardzero":
-double: 4
-float: 5
+double: 6
+float: 9
 float128: 9
 ldouble: 6
 
 Function: "j0_upward":
-double: 4
-float: 5
+double: 9
+float: 9
 float128: 7
 ldouble: 6
 
 Function: "j1":
-double: 2
+double: 4
 float: 9
 float128: 4
 ldouble: 9
 
 Function: "j1_downward":
-double: 3
-float: 6
+double: 5
+float: 8
 float128: 4
 ldouble: 4
 
 Function: "j1_towardzero":
-double: 3
-float: 6
+double: 4
+float: 8
 float128: 4
 ldouble: 4
 
 Function: "j1_upward":
-double: 3
-float: 7
+double: 9
+float: 9
 float128: 3
 ldouble: 3
 
@@ -1584,7 +1584,7 @@ float128: 4
 ldouble: 5
 
 Function: "tgamma_downward":
-double: 8
+double: 9
 float: 7
 float128: 5
 ldouble: 6
@@ -1603,49 +1603,49 @@ ldouble: 5
 
 Function: "y0":
 double: 3
-float: 8
+float: 9
 float128: 3
 ldouble: 2
 
 Function: "y0_downward":
 double: 3
-float: 6
+float: 9
 float128: 7
 ldouble: 5
 
 Function: "y0_towardzero":
-double: 3
-float: 4
+double: 4
+float: 9
 float128: 3
 ldouble: 8
 
 Function: "y0_upward":
 double: 3
-float: 6
+float: 9
 float128: 4
 ldouble: 7
 
 Function: "y1":
 double: 3
-float: 3
+float: 9
 float128: 5
 ldouble: 3
 
 Function: "y1_downward":
-double: 3
-float: 3
+double: 6
+float: 9
 float128: 5
 ldouble: 7
 
 Function: "y1_towardzero":
 double: 3
-float: 3
+float: 9
 float128: 2
 ldouble: 5
 
 Function: "y1_upward":
 double: 7
-float: 3
+float: 9
 float128: 5
 ldouble: 7
 
diff --git a/sysdeps/i386/i686/fpu/multiarch/libm-test-ulps b/sysdeps/i386/i686/fpu/multiarch/libm-test-ulps
index 79f87df47d..a39c89cec1 100644
--- a/sysdeps/i386/i686/fpu/multiarch/libm-test-ulps
+++ b/sysdeps/i386/i686/fpu/multiarch/libm-test-ulps
@@ -1100,8 +1100,8 @@ float128: 2
 ldouble: 1
 
 Function: "erfc":
-double: 3
-float: 2
+double: 5
+float: 3
 float128: 4
 ldouble: 5
 
@@ -1211,7 +1211,7 @@ ldouble: 4
 
 Function: "gamma":
 double: 4
-float: 3
+float: 5
 ldouble: 4
 
 Function: "gamma_downward":
@@ -1221,12 +1221,12 @@ ldouble: 7
 
 Function: "gamma_towardzero":
 double: 5
-float: 4
+float: 6
 ldouble: 7
 
 Function: "gamma_upward":
 double: 5
-float: 5
+float: 6
 ldouble: 6
 
 Function: "hypot":
@@ -1251,49 +1251,49 @@ ldouble: 1
 
 Function: "j0":
 double: 5
-float: 5
+float: 9
 float128: 2
 ldouble: 8
 
 Function: "j0_downward":
 double: 5
-float: 4
+float: 9
 float128: 9
 ldouble: 6
 
 Function: "j0_towardzero":
-double: 3
-float: 4
+double: 6
+float: 9
 float128: 9
 ldouble: 6
 
 Function: "j0_upward":
-double: 3
-float: 3
+double: 9
+float: 9
 float128: 7
 ldouble: 6
 
 Function: "j1":
-double: 2
-float: 5
+double: 4
+float: 9
 float128: 4
 ldouble: 9
 
 Function: "j1_downward":
-double: 3
-float: 3
+double: 5
+float: 6
 float128: 4
 ldouble: 4
 
 Function: "j1_towardzero":
-double: 3
-float: 3
+double: 4
+float: 6
 float128: 4
 ldouble: 4
 
 Function: "j1_upward":
-double: 3
-float: 6
+double: 9
+float: 9
 float128: 3
 ldouble: 3
 
@@ -1323,7 +1323,7 @@ ldouble: 5
 
 Function: "lgamma":
 double: 4
-float: 3
+float: 5
 float128: 5
 ldouble: 4
 
@@ -1335,13 +1335,13 @@ ldouble: 7
 
 Function: "lgamma_towardzero":
 double: 5
-float: 4
+float: 6
 float128: 5
 ldouble: 7
 
 Function: "lgamma_upward":
 double: 5
-float: 5
+float: 6
 float128: 8
 ldouble: 6
 
@@ -1569,62 +1569,62 @@ float128: 3
 ldouble: 4
 
 Function: "tgamma":
-double: 6
-float: 4
+double: 9
+float: 8
 float128: 4
 ldouble: 5
 
 Function: "tgamma_downward":
-double: 6
+double: 9
 float: 7
 float128: 5
 ldouble: 6
 
 Function: "tgamma_towardzero":
-double: 6
+double: 9
 float: 7
 float128: 5
 ldouble: 6
 
 Function: "tgamma_upward":
-double: 6
-float: 6
+double: 8
+float: 8
 float128: 4
 ldouble: 5
 
 Function: "y0":
-double: 2
-float: 1
+double: 3
+float: 9
 float128: 3
 ldouble: 2
 
 Function: "y0_downward":
 double: 3
-float: 4
+float: 9
 float128: 7
 ldouble: 5
 
 Function: "y0_towardzero":
-double: 3
+double: 4
 float: 4
 float128: 3
 ldouble: 8
 
 Function: "y0_upward":
 double: 3
-float: 5
+float: 9
 float128: 4
 ldouble: 7
 
 Function: "y1":
 double: 3
-float: 3
+float: 9
 float128: 5
 ldouble: 3
 
 Function: "y1_downward":
-double: 3
-float: 5
+double: 6
+float: 9
 float128: 5
 ldouble: 7
 
@@ -1636,7 +1636,7 @@ ldouble: 5
 
 Function: "y1_upward":
 double: 7
-float: 3
+float: 9
 float128: 6
 ldouble: 9
 